#include <assert.h>
#include <stdint.h>
#include <stddef.h>

#include "gpio.h"

#include "nrf_gpio.h"

int gpio_open(const struct driver *drv)
{
    assert(NULL != drv);

    struct gpio *this = (struct gpio *)(drv->dev);

    if(this->dir == OUT) {
        nrf_gpio_cfg_output((uint32_t)(this->pin));
    nrf_gpio_pin_clear(this->pin);
    }
    // FIXME: implement input configuration

    return 0;
}

int gpio_close(const struct driver *drv)
{
    assert(NULL != drv);

    struct gpio *this = (struct gpio *)(drv->dev);
    nrf_gpio_pin_clear(this->pin);

    return 0;
}

int gpio_read(const struct driver *drv, char *buffer, unsigned int len)
{
    assert(NULL != drv);

    if(len == 0) {
        return 0;
    }

    struct gpio *this = (struct gpio *)(drv->dev);

    uint32_t value = nrf_gpio_pin_read(this->pin);
    buffer[0] = value + 0x30;   // ascii convert

    return 1;
}

int gpio_write(const struct driver *drv, const char *buffer, unsigned int len)
{
    assert((NULL != drv) && (NULL != buffer));

    if(len == 0) {
        return 0;
    }

    struct gpio *this = (struct gpio *)(drv->dev);

    nrf_gpio_pin_write(this->pin, buffer[0] - 0x30);

    return 1;
}
